2018SDIBT_国庆个人第四场

A - A  这题很巧妙啊,前两天刚好做过,而且就在博客里

Little C Loves 3 I

time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

Little C loves number «3» very much. He loves all things about it.

Now he has a positive integer nn. He wants to split nn into 33 positive integers a,b,ca,b,c, such that a+b+c=na+b+c=n and none of the 33 integers is a multiple of 33. Help him to find a solution.

Input

A single line containing one integer nn (3≤n≤1093≤n≤109) — the integer Little C has.

Output

Print 33 positive integers a,b,ca,b,c in a single line, such that a+b+c=na+b+c=n and none of them is a multiple of 33.

It can be proved that there is at least one solution. If there are multiple solutions, print any of them.

Examples

input

Copy

3

output

Copy

1 1 1

input

Copy

233

output

Copy

77 77 79被样例困惑了很久,看了题解啧啧,其实这题就是构造大致题意:给你一个数n,找到三个数a,b,c,使得a+b+c=n,并且a,b,c都不能是3的倍数分析:当n%3=0时,n-2一定不是3的倍数,可以构造为a=1,b=1,c=n-2;当n%3!=0时,n-3一定不是3的倍数,那么可以构造为,a=1,b=2,c=n-3.注意这个构造是任意的,只要满足条件即可

 1 #include<cstdio>
 2 #include<cstring>
 3 #include<algorithm>
 4 using namespace std;
 5 int main()
 6 {
 7     int n;
 8     while(~scanf("%d",&n))
 9     {
10         if(n%3==0)
11             printf("1 1 %d\n",n-2);
12         else
13             printf("1 2 %d\n",n-3);
14     }
15     return 0;
16 }

B. Cover Points//这题也刚好做过

time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

There are nn points on the plane, (x1,y1),(x2,y2),…,(xn,yn)(x1,y1),(x2,y2),…,(xn,yn).

You need to place an isosceles triangle with two sides on the coordinate axis to cover all points (a point is covered if it lies inside the triangle or on the side of the triangle). Calculate the minimum length of the shorter side of the triangle.

Input

First line contains one integer nn (1≤n≤1051≤n≤105).

Each of the next nn lines contains two integers xixi and yiyi (1≤xi,yi≤1091≤xi,yi≤109).

Output

Print the minimum length of the shorter side of the triangle. It can be proved that it‘s always an integer.

Examples

input

Copy

31 11 22 1

output

Copy

3

input

Copy

41 11 22 12 2

output

Copy

4

Note

Illustration for the first example:

Illustration for the second example:

题意:唔就是,让你找到一个最小的等腰三角形,使得给出的所有点都包含在等腰三角形里或者等腰三角形边上

分析:  其实就是找给出的点在y轴上截距最大的时候,满足方程y=-x+b,移一下就是,x+y=b,只要找到x+y的最大值即可、

 1 #include<cstdio>
 2 #include<cstring>
 3 #include<algorithm>
 4 #include<cmath>
 5 using namespace std;
 6 int main()
 7 {
 8     int n;
 9     while(~scanf("%d",&n))
10     {
11         int a,b,ans=0;
12         while(n--)
13         {
14             scanf("%d %d",&a,&b);
15             ans=max(a+b,ans);
16         }
17         printf("%d\n",ans);
18     }
19     return 0;
20 }

C - C Karen and Morning

Description

Karen is getting ready for a new school day!

It is currently hh:mm, given in a 24-hour format. As you know, Karen loves palindromes, and she believes that it is good luck to wake up when the time is a palindrome.

What is the minimum number of minutes she should sleep, such that, when she wakes up, the time is a palindrome?

Remember that a palindrome is a string that reads the same forwards and backwards. For instance, 05:39 is not a palindrome, because 05:39 backwards is 93:50. On the other hand, 05:50 is a palindrome, because 05:50 backwards is 05:50.

Input

The first and only line of input contains a single string in the format hh:mm (00 ≤ hh ≤ 23, 00 ≤ mm ≤ 59).

Output

Output a single integer on a line by itself, the minimum number of minutes she should sleep, such that, when she wakes up, the time is a palindrome.

Sample Input

Input

05:39

Output

11

Input

13:31

Output

0

Input

23:59

Output

1

Hint

In the first test case, the minimum number of minutes Karen should sleep for is 11. She can wake up at 05:50, when the time is a palindrome.

In the second test case, Karen can wake up immediately, as the current time, 13:31, is already a palindrome.

In the third test case, the minimum number of minutes Karen should sleep for is 1 minute. She can wake up at 00:00, when the time is a palindrome.

题意:这个女孩每到一个回文时间就会醒来,问她最少能睡多长时间。输入的字符串格式一定是hh:xx格式

分析:模拟就好

 1 #include<cstdio>
 2 #include<algorithm>
 3 #include<iostream>
 4 #include<cstring>
 5 #include<cmath>
 6 using namespace std;
 7 int main()
 8 {
 9     char s[10];
10     while(~scanf("%s",s))
11     {
12         int a,b;
13         a=(s[0]-‘0‘)*10+s[1]-‘0‘;//a是小时
14         b=(s[3]-‘0‘)*10+s[4]-‘0‘;//b是分钟
15         //printf("%d %d",a,b);
16         int q,w,e,r,j,t,tt,flag=0,i;
17         for(i=a;i<=23;i++)//注意只有1-23小时
18         {
19                 q=i/10;
20                 w=i%10;
21             if(i==a)
22                 j=b;
23             else
24                 j=0;
25             for(;j<=59;j++)//只有0-59秒
26             {
27
28                 e=j/10;
29                 r=j%10;
30                 if(q==r&&w==e)
31                 {
32                     t=i,tt=j;
33                     flag=1;
34                     break;
35                 }
36             }
37             if(flag==1)
38                 break;
39         }
40 //        printf("%d %d\n",t,tt);
41         if(flag==1)
42         {
43             if(t==a)
44                 printf("%d\n",tt-b);//当在原来的小时形成回文时,只需要减去分钟数就好
45             else
46             printf("%d\n",(t-a-1)*60+60-b+tt);//间隔了t-a-1个小时
47         }
48         if(flag==0&&i==24)
49             printf("%d\n",(24-a-1)*60+60-b);
50     }
51     return 0;
52 }

D - D

Karen and Coffee

time limit per test

2.5 seconds

memory limit per test

512 megabytes

input

standard input

output

standard output

To stay woke and attentive during classes, Karen needs some coffee!

Karen, a coffee aficionado, wants to know the optimal temperature for brewing the perfect cup of coffee. Indeed, she has spent some time reading several recipe books, including the universally acclaimed "The Art of the Covfefe".

She knows n coffee recipes. The i-th recipe suggests that coffee should be brewed between li and ri degrees, inclusive, to achieve the optimal taste.

Karen thinks that a temperature is admissible if at least k recipes recommend it.

Karen has a rather fickle mind, and so she asks q questions. In each question, given that she only wants to prepare coffee with a temperature between a and b, inclusive, can you tell her how many admissible integer temperatures fall within the range?

Input

The first line of input contains three integers, nk (1 ≤ k ≤ n ≤ 200000), and q (1 ≤ q ≤ 200000), the number of recipes, the minimum number of recipes a certain temperature must be recommended by to be admissible, and the number of questions Karen has, respectively.

The next n lines describe the recipes. Specifically, the i-th line among these contains two integers li and ri (1 ≤ li ≤ ri ≤ 200000), describing that the i-th recipe suggests that the coffee be brewed between li and ri degrees, inclusive.

The next q lines describe the questions. Each of these lines contains a and b, (1 ≤ a ≤ b ≤ 200000), describing that she wants to know the number of admissible integer temperatures between a and b degrees, inclusive.

Output

For each question, output a single integer on a line by itself, the number of admissible integer temperatures between a and b degrees, inclusive.

Examples

input

Copy

3 2 491 9492 9797 9992 9493 9795 9690 100

output

Copy

3304

input

Copy

2 1 11 1200000 20000090 100

output

Copy

0

Note

In the first test case, Karen knows 3 recipes.

  1. The first one recommends brewing the coffee between 91 and 94 degrees, inclusive.
  2. The second one recommends brewing the coffee between 92 and 97 degrees, inclusive.
  3. The third one recommends brewing the coffee between 97 and 99 degrees, inclusive.

A temperature is admissible if at least 2 recipes recommend it.

She asks 4 questions.

In her first question, she wants to know the number of admissible integer temperatures between 92 and 94 degrees, inclusive. There are 3: 92, 93 and 94 degrees are all admissible.

In her second question, she wants to know the number of admissible integer temperatures between 93 and 97 degrees, inclusive. There are 3: 93, 94 and 97 degrees are all admissible.

In her third question, she wants to know the number of admissible integer temperatures between 95 and 96 degrees, inclusive. There are none.

In her final question, she wants to know the number of admissible integer temperatures between 90 and 100 degrees, inclusive. There are 4: 92, 93, 94 and 97 degrees are all admissible.

In the second test case, Karen knows 2 recipes.

  1. The first one, "wikiHow to make Cold Brew Coffee", recommends brewing the coffee at exactly 1 degree.
  2. The second one, "What good is coffee that isn‘t brewed at at least 36.3306 times the temperature of the surface of the sun?", recommends brewing the coffee at exactly 200000 degrees.

A temperature is admissible if at least 1 recipe recommends it.

In her first and only question, she wants to know the number of admissible integer temperatures that are actually reasonable. There are none.

题意:有n个食谱,告诉你n段温度适合煮咖啡,如果某个温度被至少k个食谱里的温度包含,则符合条件,你有q次查询,让你求出每次查询中符合条件的温度的数量

分析:看数据量,暴力肯定不行,看代码吧

 1 #include<cstdio>
 2 #include<cstring>
 3 #include<algorithm>
 4 const int m = 2e5;
 5 int main()
 6 {
 7     int n,k,q,a[m];
 8     while(~scanf("%d %d %d",&n,&k,&q))
 9     {
10         int l,r;
11         memset(a,0,sizeof(a));
12         for(int i=1;i<=n;i++)
13             {
14              scanf("%d %d",&l,&r);
15              a[l]++;
16              a[r+1]--;
17             }
18         for(int i=1;i<=m;i++)
19         {
20             a[i]+=a[i-1];
21         }
22         for(int i=1;i<=m;i++)
23         {
24             a[i]=a[i-1]+(a[i]>=k);
25         }
26         for(int i=1;i<=q;i++)
27         {
28             scanf("%d %d",&l,&r);
29             printf("%d\n",a[r]-a[l-1]);
30         }
31     }
32     return 0;
33 }

不会解释,贴一个题解的链接https://blog.csdn.net/nka_kun/article/details/73411740

E - E Karen and Game 816c

time limit per test

2 seconds

memory limit per test

512 megabytes

input

standard input

output

standard output

On the way to school, Karen became fixated on the puzzle game on her phone!

The game is played as follows. In each level, you have a grid with n rows and m columns. Each cell originally contains the number 0.

One move consists of choosing one row or column, and adding 1 to all of the cells in that row or column.

To win the level, after all the moves, the number in the cell at the i-th row and j-th column should be equal to gi, j.

Karen is stuck on one level, and wants to know a way to beat this level using the minimum number of moves. Please, help her with this task!

Input

The first line of input contains two integers, n and m (1 ≤ n, m ≤ 100), the number of rows and the number of columns in the grid, respectively.

The next n lines each contain m integers. In particular, the j-th integer in the i-th of these rows contains gi, j (0 ≤ gi, j ≤ 500).

Output

If there is an error and it is actually not possible to beat the level, output a single integer -1.

Otherwise, on the first line, output a single integer k, the minimum number of moves necessary to beat the level.

The next k lines should each contain one of the following, describing the moves in the order they must be done:

  • row x, (1 ≤ x ≤ n) describing a move of the form "choose the x-th row".
  • col x, (1 ≤ x ≤ m) describing a move of the form "choose the x-th column".

If there are multiple optimal solutions, output any one of them.

Examples

input

Copy

3 52 2 2 3 20 0 0 1 01 1 1 2 1

output

Copy

4row 1row 1col 4row 3

input

Copy

3 30 0 00 1 00 0 0

output

Copy

-1

input

Copy

3 31 1 11 1 11 1 1

output

Copy

3row 1row 2row 3

Note

In the first test case, Karen has a grid with 3 rows and 5 columns. She can perform the following 4 moves to beat the level:

In the second test case, Karen has a grid with 3 rows and 3 columns. It is clear that it is impossible to beat the level; performing any move will create three 1s on the grid, but it is required to only have one 1 in the center.

In the third test case, Karen has a grid with 3 rows and 3 columns. She can perform the following 3 moves to beat the level:

Note that this is not the only solution; another solution, among others, is col 1, col 2, col 3.

题意:你有一个n×m的矩阵,且全为0,要变成所给出的矩阵,操作要么每行都加1,要么每列都加1,如果可以输出操作的行和列,否则输出-1

分析:这道题其实就是一个模拟的过程,将所给出的矩阵每列或每行减一,看最后的矩阵是否全为0,但要注意两个问题:1:数组大小的问题,一开始数组开太小导致w了好多发;2:当行数小于列数时,先执行消除行的操作;当列数小于行数的时候,先执行消除列的操作。

#include<cstdio>
#include<algorithm>
#include<iostream>
#include<cstring>
#include<cmath>
using namespace std;
int main()
{
    int a[505][505],b[505][505],c[505],d[50005],aa[50005],bb[50005],n,m,e[50005],f[50005];
    while(~scanf("%d %d",&n,&m))
    {
        memset(b,0,sizeof(b));
        for(int i=0;i<n;i++)
        {
            for(int j=0;j<m;j++)
            {
                scanf("%d",&a[i][j]);
            }
//            printf("%d\n",c[i]);
        }//找到每一行最小的那个数
                int t=0,tt=0;
        if(n<m)//如果行数小于列数,先消除行
        {

        for(int i=0;i<n;i++)
        {
            for(int j=0;j<m;j++)
            {
                d[j]=a[i][j];
            }
            sort(d,d+m);
            c[i]=d[0];
        }
        for(int i=0;i<n;i++)
        {
            for(int k=0;k<c[i];k++)
                aa[t++]=i;
//                printf("row %d\n",i);

            for(int j=0;j<m;j++)
            {
                a[i][j]-=c[i];//每一行每个数减去最小的那个数
            }
//            for(int j=1;j<=m;j++)
//            {
//                printf("%d ",a[i][j]);
//            }
//            printf("\n");
        }
        for(int j=0;j<m;j++)
        {
            for(int i=0;i<n;i++)
            {
                e[i]=a[i][j];
            }
            sort(e,e+n);
//            printf("%d\n",e[0]);
            f[j]=e[0];//找到每列最小的那个数
        }
        for(int j=0;j<m;j++)
        {
            for(int k=0;k<f[j];k++)
                bb[tt++]=j;
//                printf("col %d\n",j);
            for(int i=0;i<n;i++)
            {
                a[i][j]-=f[j];//每列每个数减去每列最小的那个数
            }
        }
        }
        else//如果列数小于行数,先消除列数
        {
            for(int j=0;j<m;j++)
        {
            for(int i=0;i<n;i++)
            {
                e[i]=a[i][j];
            }
            sort(e,e+n);
//            printf("%d\n",e[0]);
            f[j]=e[0];//找到每列最小的那个数
        }
        for(int j=0;j<m;j++)
        {
            for(int k=0;k<f[j];k++)
                bb[tt++]=j;
//                printf("col %d\n",j);
            for(int i=0;i<n;i++)
            {
                a[i][j]-=f[j];//每列每个数减去每列最小的那个数
            }
        }
        for(int i=0;i<n;i++)
        {
            for(int j=0;j<m;j++)
            {
                d[j]=a[i][j];
            }
            sort(d,d+m);
            c[i]=d[0];
        }
        for(int i=0;i<n;i++)
        {
            for(int k=0;k<c[i];k++)
                aa[t++]=i;
//                printf("row %d\n",i);

            for(int j=0;j<m;j++)
            {
                a[i][j]-=c[i];//每一行每个数减去最小的那个数
            }
//            for(int j=1;j<=m;j++)
//            {
//                printf("%d ",a[i][j]);
//            }
//            printf("\n");
        }
        }
        int flag=0;
        for(int i=0;i<n;i++)
        {
            for(int j=0;j<m;j++)
            {
                if(a[i][j]!=b[i][j])//b为全是0的矩阵
                {
                    flag=1;
                    break;
                }
            }
        }//与全是0的矩阵比较,如果不相等则跳出
        if(flag==1)
        {
            printf("-1\n");
        }
        else
        {
            printf("%d\n",t+tt);
            for(int i=0;i<t;i++)
                printf("row %d\n",aa[i]+1);
            for(int i=0;i<tt;i++)
                printf("col %d\n",bb[i]+1);
        }
    }
    return 0;
}

原文地址:https://www.cnblogs.com/LLLAIH/p/9742663.html

时间: 2024-07-31 10:22:32

2018SDIBT_国庆个人第四场的相关文章

2018SDIBT_国庆个人第三场

A - A CodeForces - 1042A There are nn benches in the Berland Central park. It is known that aiai people are currently sitting on the ii-th bench. Another mm people are coming to the park and each of them is going to have a seat on some bench out of n

国庆个人第四场

Little C Loves 3 I Description Little C loves number «3» very much. He loves all things about it. Now he has a positive integer nn. He wants to split nn into 33 positive integers a,b,ca,b,c, such that a+b+c=na+b+c=n and none of the 33 integers is a m

2018SDIBT_国庆个人第五场

A - ACodeForces 1060A Description Let's call a string a phone number if it has length 11 and fits the pattern "8xxxxxxxxxx", where each "x" is replaced by a digit. For example, "80123456789" and "80000000000" are ph

2018SDIBT_国庆个人第七场

A - Complete the Word(暴力) Description ZS the Coder loves to read the dictionary. He thinks that a word is nice if there exists a substring (contiguous segment of letters) of it of length 26 where each letter of English alphabet appears exactly once.

计蒜客 2016计蒜之道比赛 初赛第四场 记录

T1  淘宝流量分配 在每年的淘宝“双十一”时,访问量都会暴涨,服务器的请求会被流量分配程序按照一定策略,分发给不同的进程去处理.有一类请求,有两个进程可以接受分发的请求,其中一个进程所在服务器的配置.网络传输性能等都要优于另一个进程.流量分发程序可以知道队列中每个任务的预计处理时间,每次都会尽可能将队列中预计处理时间更多的任务分配给性能更优的进程. 假设队列当前一共有 nn 个任务待分配,第 ii 个任务的预计处理时间为 a_i(1 \leq i \leq n)a?i??(1≤i≤n).由于服

HDOJ多校联合第四场

B题: C题:仅由'A','G','C','T',4个字母组成,给定一个字符串S,|S|<=15,给定一个整数m,以m为长度且仅含4种字母的字符串T,求LCS(S,T)为0,1,2,3....|S|,时相应字符串T的数目. 分析:dp+状态压缩 反正我不会这题,也是看了羊神的代码之后才明白这题的思路 下面说说我的理解吧: 由于|S|长度最大为15,所以用一个二进制编码表示是哪些位置上的字母构成LCS,并求相应的数目. dp[0][st],dp[1][st]记录的是相应字母构成LCS时,T可能的数

hdu5336 多校联合第四场1010 模拟+bfs优先队列

http://acm.hdu.edu.cn/showproblem.php?pid=5336 Problem Description XYZ is playing an interesting game called "drops". It is played on a r?c grid. Each grid cell is either empty, or occupied by a waterdrop. Each waterdrop has a property "siz

[hdu 4899]14年多校第四场C Hero meet devil 状压DP

Time Limit: 16000/8000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Total Submission(s): 122    Accepted Submission(s): 49 Problem Description There is an old country and the king fell in love with a devil. The devil always asks th

STD 第四场 1001 1002 1004

HDU 5327 5328 5335 #include <stdio.h> #include <iostream> #include <string.h> #include <stack> #include <algorithm> #include <queue> #include <map> #include <cmath> #define eps 0.00000001 #define pi acos(-1,